import re,sys,struct

argument = sys.argv[1]
argument2 = chr(0x5F) + argument


out = open(argument2,"wb")
input = open(argument,"rb")

data = input.read(4)
if data[:4] != "\x56\x67\x6D\x20":				#Check for VGM header magic "Vgm "
	print "Data is not VGM. Exiting."
	out.close()
	raise SystemExit
out.write(data)

data = input.read(4)
t_fsize = int(struct.unpack('<I', data[:4])[0]) + 4
print "Total filesize is " + str(t_fsize)
out.write(data)

data = input.read(4)
vgm_ver = hex(struct.unpack('<I', data[:4])[0])
print "VGM Version is " + str(vgm_ver)
print "Forcing ver 1.51"
data = "\x51\x01\x00\x00"
out.write(data)

data = input.read(4)
DCSG_CLK = int(struct.unpack('<I', data[:4])[0])
if DCSG_CLK != 0:
	print "SN76489(DCSG) clock is " + str(DCSG_CLK) + "Hz"
print "Forcing 3579545Hz"
data = "\x99\x93\x36\x00"
out.write(data)

data = input.read(4)
OPLL_CLK = int(struct.unpack('<I', data[:4])[0])
if OPLL_CLK != 0:
	print "YM2413(OPLL) clock is " + str(OPLL_CLK) + "Hz"
out.write(data)

data = input.read(4)
GD3_offset = int(struct.unpack('<I', data[:4])[0])
if GD3_offset != 0:
	print "GD3 tag is at the offset " + str(GD3_offset) + " within the file."
out.write(data)

data = input.read(4)
total_samples = int(struct.unpack('<I', data[:4])[0])
if total_samples != 0:
	print "Total wait time in samples is " + str(total_samples)
out.write(data)

data = input.read(4)
loop_offset = int(struct.unpack('<I', data[:4])[0])
if loop_offset != 0:
	print "Loop offset is at position " + str(loop_offset)
out.write(data)

data = input.read(4)
loop_size = int(struct.unpack('<I', data[:4])[0])
if loop_size != 0:
	print "Loop block size is " + str(loop_size)
out.write(data)
data = input.read(4)
vert_rate = int(struct.unpack('<I', data[:4])[0])
if vert_rate != 0:
	print "Vertical rate is " + str(vert_rate) + "Hz"
out.write(data)
data = input.read(2)
DCSG_FB = int(struct.unpack('<H', data[:2])[0])
if DCSG_FB != 0:
	if DCSG_FB == 0x003:
		print "DCSG is SN76489AN (ColecoVision/SC-3000H/SG-1000 MK1/BBC MICRO)"
	if DCSG_FB == 0x006:
		print "DCSG is SN76494, SN76496 (no clock divider)"
	if DCSG_FB == 0x006:
		print "DCSG is integrated SN76489AN equivalent(Yamaha VDPs/Game Gear)"
out.write(data)
data = input.read(1)
DCSG_NOISE = int(struct.unpack('<B', data[:1])[0])
if DCSG_NOISE != 0:
	if DCSG_NOISE == 0x0F:
		print "DCSG noise is set as SN76489AN (ColecoVision/SC-3000H/SG-1000 MK1/BBC MICRO)"
	if DCSG_NOISE == 0x10:
		print "DCSG noise is set as integrated SN76489AN equivalent(Yamaha VDPs/Game Gear)"
out.write(data)
data = input.read(1)
DCSG_FLAGS = int(struct.unpack('<B', data[:1])[0])
#Currently storing but doing nothing with DCSG_FLAGS  (1.51 feature)
out.write(data)
data = input.read(4)
OPN2_CLK = int(struct.unpack('<I', data[:4])[0])
if OPN2_CLK != 0:
	print "YM2612(OPN2) clock is " + str(OPN2_CLK) + "Hz"
if OPN2_CLK == 0:
	data = "\xB5\x0A\x75\x00"
out.write(data)
data = input.read(4)
OPM_CLK = int(struct.unpack('<I', data[:4])[0])
if OPM_CLK != 0:
	print "YM2151(OPM) clock is " + str(OPM_CLK)
out.write(data)
data = input.read(4)
DATA_START = (int(struct.unpack('<I', data[:4])[0]) + 0x34)
print "The data start offset is is " + str(DATA_START + 0x34)
out.write(data)
data = input.read(4)
SEGAPCM_CLK = int(struct.unpack('<I', data[:4])[0])
if SEGAPCM_CLK != 0:
	print "SEGA PCM(315-5218) clock is " + str(SEGAPCM_CLK) + "Hz"
out.write(data)
data = input.read(4)
SEGAPCM_IF = int(struct.unpack('<I', data[:4])[0])
if SEGAPCM_IF != 0:
	print "SEGA PCM(315-5218) I/F value is " + str(SEGAPCM_IF)
out.write(data)
data = input.read(4)
RF5C68_CLK = int(struct.unpack('<I', data[:4])[0])
if RF5C68_CLK != 0:
	print "RF5C68 clock is " + str(RF5C68_CLK) + "Hz"
out.write(data)
data = input.read(4)
YM2203_CLK = int(struct.unpack('<I', data[:4])[0])
if YM2203_CLK != 0:
	print "YM2203 clock is " + str(YM2203_CLK) + "Hz"
	print "Setting as 0."
	data = "\x00\x00\x00\x00"
out.write(data)
data = input.read(4)
YM2608_CLK = int(struct.unpack('<I', data[:4])[0])
if YM2608_CLK != 0:
	print "YM2608 clock is " + str(YM2608_CLK) + "Hz"
out.write(data)

data = input.read(4)
YM2610_CLK = int(struct.unpack('<I', data[:4])[0])
if YM2610_CLK != 0:
	print "YM2610 clock is " + str(YM2610_CLK) + "Hz"
out.write(data)

data = input.read(DATA_START - 4)
out.write(data)

#Data translation loop
input.seek(DATA_START)
out.seek(DATA_START)
while True:
 data = input.read(1)
 if not data: break

 if ord(data) == 0x66:
	out.write(data)
	break

 while True:

		if ord(data) == 0x55:
			data = chr(0x52)
			out.write(data)
			data = input.read(1)
			out.write(data)
			data = input.read(1)
			out.write(data)   
			break

		if ord(data) == 0xA5:
			data = input.read(1)
			saved = data
			if ord(saved) == 0x28:
				data = chr(0x52)
				out.write(data)
				out.write(saved)
				data = input.read(1)
				data = chr(ord(data) + 4)
				out.write(data)   
				break
			data = chr(0x53)
			out.write(data)
			out.write(saved)
			data = input.read(1)
			out.write(data)   
			break

		if ord(data) == 0x61:
			out.write(data)
			data = input.read(1)
			out.write(data)
			data = input.read(1)
			out.write(data)   
			break

		if ord(data) == 0x62:
			out.write(data)
			break

		if ord(data) == 0x63:
			out.write(data)
			break

		if ord(data) >= 0x70 and ord(data) <= 0x7F:
			out.write(data)
			break

		if ord(data) == 0xA0:
			data = chr(0x52)
			out.write(data)
			data = input.read(1)
			out.write(data)
			data = input.read(1)
			out.write(data)   
			break


		break

#Copy over the GD3 data
while True:
 data = input.read(1)
 if not data: break
 out.write(data)

#Close all files
out.close()
